{% extends "customers/base.html" %}
{% load i18n %}
{% load staticfiles %}
{% load active_tag %}
{% load md2 %}

{% block title %}Reportes{% endblock %}

{% block extra_head %}
<link href="{% static 'theme/plugins/c3/c3.min.css' %}" rel="stylesheet" type="text/css">
<link href="{% static 'theme/plugins/smartwizard/dist/css/smart_wizard.css' %}" rel="stylesheet" type="text/css">
{% endblock extra_head %}

{% block page %}
<!-- begin breadcrumb -->
<ol class="breadcrumb float-xl-right">
		<li class="breadcrumb-item"><a href="{% url 'home' %}">Home</a></li>
    <li class="breadcrumb-item active">Reportes personalizados</li>
	</ol>
	<!-- end breadcrumb -->

	<!-- begin page-header -->
	<h1 class="page-header">Reportes personalizados</h1>
	<!-- end page-header -->

		<!-- begin row -->
		<div class="row">
				<!-- begin col-12 -->
				<div class="col-xl-12 ui-sortable">
					<!-- begin panel -->
					<div class="panel panel-inverse" data-sortable-id="ui-general-1">
						<!-- begin panel-heading -->
						<div class="panel-heading ui-sortable-handle">
							<h4 class="panel-title">Reportes personalizados</h4>
							<div class="panel-heading-btn">
								<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-default" data-click="panel-expand"><i class="fa fa-expand"></i></a>
								<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-success" data-click="panel-reload"><i class="fa fa-redo"></i></a>
								<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-warning" data-click="panel-collapse"><i class="fa fa-minus"></i></a>
								<a href="javascript:;" class="btn btn-xs btn-icon btn-circle btn-danger" data-click="panel-remove"><i class="fa fa-times"></i></a>
							</div>
						</div>
						<!-- end panel-heading -->
						<!-- begin panel-body -->
						<div class="panel-body">
							<div id="service-status-app">
									{% csrf_token %}
									<div id="wizard">
										<!-- begin wizard-step -->
										<ul>
											<li>
												<a href="#step-1">
													<span class="number">1</span> 
													<span class="info">
														Modelo Base
														<small>Seleccione modelo base</small>
													</span>
												</a>
											</li>
											<li>
												<a href="#step-2">
													<span class="number">2</span> 
													<span class="info">
														Campos
														<small>Seleccione campos </small>
													</span>
												</a>
											</li>
											<li>
												<a href="#step-3">
													<span class="number">3</span>
													<span class="info">
														Filtros
														<small>Seleccione filtros</small>
													</span>
												</a>
											</li>
											<li>
												<a href="#step-4">
													<span class="number">4</span> 
													<span class="info">
														Acción
														<small>Seleccione acción</small>
													</span>
												</a>
											</li>
										</ul>
										<div>
											<div id="step-1">
												<!-- begin fieldset -->
												<fieldset>
													<!-- begin row -->
													<div class="row">
														<!-- begin col-8 -->
														<div class="col-xl-8 offset-xl-1">
															<br>
															<div class="row mb-3">
																<label class="form-label col-form-label col-md-2">Modelo Base</label>
																<div class="col-md-5">
																	<v-select v-model="selectedBase" :options="baseOptions" ></v-select>
																</div>
															</div>
														</div>
														<!-- end col-8 -->
													</div>
													<!-- end row -->
												</fieldset>
												<!-- end fieldset -->
											</div>
											<div id="step-2">
												<!-- begin fieldset -->
												<fieldset>
													<!-- begin row -->
													<div class="row">
														<!-- begin col-8 -->
														<div class="col-xl-8 offset-xl-1">
															<br>
															<div v-if="selectedBase.value === 0">
																{% for col in columns.0 %}
																<div class="form-check form-check-inline">
																	<label><input type="checkbox" id=cx{{col.0}} value="{{col.0}}">{{col.1}}</label><br>
																</div>
																{%endfor%}
															</div>
															<div v-else-if="selectedBase.value === 1">
																{% for col in columns.1 %}
																<div class="form-check form-check-inline">
																	<label><input type="checkbox" id=cx{{col.0}} value="{{col.0}}">{{col.1}}</label><br>
																</div>
																{%endfor%}
															</div>
															<div v-else-if="selectedBase.value === 2">
																{% for col in columns.2 %}
																<div class="form-check form-check-inline">
																	<label><input type="checkbox" id=cx{{col.0}} value="{{col.0}}">{{col.1}}</label><br>
																</div>
																{%endfor%}
															</div>
															<div v-else>
																{% for col in columns.3 %}
																<div class="form-check form-check-inline">
																	<label><input type="checkbox" id=cx{{col.0}} value="{{col.0}}">{{col.1}}</label><br>
																</div>
																{%endfor%}
															</div><br>
														</div>
														<!-- end col-8 -->
													</div>
													<!-- end row -->
												</fieldset>
												<!-- end fieldset -->
											</div>
											<div id="step-3">
												<!-- begin fieldset -->
												<fieldset>
													<!-- begin row -->
													<div class="row">
														<!-- begin col-8 -->
														<div class="col-xl-8 offset-xl-1">
															<br>
															<form id="filtros" class="form-horizontal">
																<div class="tab-content">
																	<div id="general" role="tabpanel" class="tab-pane active">
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Nombre:</label>
																			<div class="col-sm-9">
																				<input class = "form-control col-6" type="search" v-model="filter_name"></input>
																			</div>
																		  </div>
																	</div>
																	<div v-if="selectedBase.value === 0 || selectedBase.value === 1">
																		<div id="general" role="tabpanel" class="tab-pane active">
																			<div class="form-group row m-b-15">
																				<label class="col-form-label col-md-3">Dirección:</label>
																				<div class="col-sm-9">
																					<input class = "form-control col-6" type="search" v-model="filter_address">	
																				</div>
																			</div>
																		</div>
																		<div id="general" role="tabpanel" class="tab-pane active">
																			<div class="form-group row m-b-15">
																				<label class="col-form-label col-md-3">Estado de Red:</label>
																				<div class="col-sm-5">
																					<v-select v-model="selectedNetwork" :options="networkOptions"></v-select>
																				</div>
																			</div>
																		</div>
																		<div id="general" role="tabpanel" class="tab-pane active">
																			<div class="form-group row m-b-15">
																				<label class="col-form-label col-md-3">Plan:</label>
																				<div class="col-sm-5">
																					<v-select v-model="selectedPlan" :options="planOptions"></v-select>
																				</div>
																			</div>
																		</div>
																	</div>
																	<div id="general" role="tabpanel" class="tab-pane active">
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Fecha de Creación Desde:</label>
																			<div class="col-sm-9">
																				<input class="form-control col-6" type="date" v-model="initDateCreated">
																			</div>
																			<label class="col-form-label col-md-3">Fecha de Creación Hasta:</label>
																			<div class="col-sm-9">
																				<input class="form-control col-6" type="date" v-model="finalDateCreated">
																			</div>
																		</div>
																	</div>
																	<div v-if="selectedBase.value === 0">
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Balance Desde:</label>
																			<div class="col-sm-9">
																				<input class="form-control col-6" type="Number" v-model="filter_from_balance"></input>
																			</div>
																			<label class="col-form-label col-md-3">Balance Hasta:</label>
																			<div class="col-sm-9">
																				<input class="form-control col-6" type="Number" v-model="filter_to_balance"></input>
																			</div>
																		</div>
																		<div id="general" role="tabpanel" class="tab-pane active">
																			<div class="form-group row m-b-15">
																				<label class="col-form-label col-md-3">Tipo de Cliente:</label>
																				<div class="col-sm-5">
																					<v-select v-model="selectedCustomerKind" :options="customerKindOptions"></v-select>
																				</div>
																			</div>
																		</div>
																	</div>
																	<div v-if="selectedBase.value === 1">
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Fecha Activación Desde:</label>
																			<div class="col-sm-9">
																				<input class="form-control col-6" type="date" v-model="initDateActivated">
																			</div>
																			<label class="col-form-label col-md-3">Fecha Activación Hasta:</label>
																			<div class="col-sm-9">
																				<input class="form-control col-6" type="date" v-model="finalDateActivated">
																			</div>
																		</div>
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Fecha Instalación Desde:</label>
																			<div class="col-sm-9">
																				<input class="form-control col-6" type="date" v-model="initDateInstalled">
																			</div>
																			<label class="col-form-label col-md-3">Fecha Instalación Hasta:</label>
																			<div class="col-sm-9">
																				<input class="form-control col-6" type="date" v-model="finalDateInstalled">
																			</div>
																		</div>
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Desinstalado Desde:</label>
																			<div class="col-sm-9">
																				<input class="form-control col-6" type="date" v-model="initDateUninstalled">
																			</div>
																			<label class="col-form-label col-md-3">Desinstalado Hasta:</label>
																			<div class="col-sm-9">
																				<input class="form-control col-6" type="date" v-model="finalDateUninstalled">
																			</div>
																		</div>
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Fecha Expiración Desde:</label>
																			<div class="col-sm-9">
																				<input class="form-control col-6" type="date" v-model="initDateExpired">
																			</div>
																			<label class="col-form-label col-md-3">Fecha Expiración Hasta:</label>
																			<div class="col-sm-9">
																				<input class="form-control col-6" type="date" v-model="finalDateExpired">
																			</div>
																		</div>
																		<div id="general" role="tabpanel" class="tab-pane active">
																			<div class="form-group row m-b-15">
																				<label class="col-form-label col-md-3">Tecnología:</label>
																				<div class="col-sm-5">
																					<v-select v-model="selectedTechnology" :options="technologyOptions"></v-select>
																				</div>
																			</div>
																		</div>
																		<div id="general" role="tabpanel" class="tab-pane active">
																			<div class="form-group row m-b-15">
																				<label class="col-form-label col-md-3">Status:</label>
																				<div class="col-sm-5">
																					<v-select v-model="selectedStatus" :options="statusOptions"></v-select>
																				</div>
																			</div>
																		</div>
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Cambio Status Desde:</label>
																			<div class="col-sm-9">
																				<input class="form-control col-6" type="date" v-model="initDateStatus">
																			</div>
																			<label class="col-form-label col-md-3">Cambio Status Hasta:</label>
																			<div class="col-sm-9">
																				<input class="form-control col-6" type="date" v-model="finalDateStatus">
																			</div>
																		</div>
																	</div>
																</div>
																<div v-if="selectedBase.value === 2">
																	<div id="general" role="tabpanel" class="tab-pane active">
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Método:</label>
																			<div class="col-sm-5">
																				<v-select v-model="selectedPaymentKind" :options="paymentKindOptions"></v-select>
																			</div>
																		</div>
																	</div>
																	<div id="general" role="tabpanel" class="tab-pane active">
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Manual:</label>
																			<div class="col-sm-5">
																				<v-select v-model="selectedManual" :options="manualOptions"></v-select>
																			</div>
																		</div>
																	</div>
																	<div id="general" role="tabpanel" class="tab-pane active">
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Operador Cliente:</label>
																			<div class="col-sm-5">
																				<v-select v-model="selectedOpCliente" :options="opClienteOptions"></v-select>
																			</div>
																		</div>
																	</div>
																	<div id="general" role="tabpanel" class="tab-pane active">
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Operador Pago:</label>
																			<div class="col-sm-5">
																				<v-select v-model="selectedOpPayment" :options="opPaymentOptions"></v-select>
																			</div>
																		</div>
																	</div>
																	<div id="general" role="tabpanel" class="tab-pane active">
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Agente:</label>
																			<div class="col-sm-5">
																				<v-select v-model="selectedAgent" :options="agentOptions"></v-select>
																			</div>
																		</div>
																	</div>
																	<div id="general" role="tabpanel" class="tab-pane active">
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Conciliado:</label>
																			<div class="col-sm-5">
																				<v-select v-model="selectedConciliado" :options="conciliadoOptions"></v-select>
																			</div>
																		</div>
																	</div>
																	<div id="general" role="tabpanel" class="tab-pane active">
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Servicio Asignado:</label>
																			<div class="col-sm-5">
																				<v-select v-model="selectedServicioAsignado" :options="servicioAsignadoOptions"></v-select>
																			</div>
																		</div>
																	</div>
																	<div class="form-group row m-b-15">
																		<label class="col-form-label col-md-3">Fecha de Pago Desde:</label>
																		<div class="col-sm-9">
																			<input class="form-control col-6" type="date" v-model="initDatePayment">
																		</div>
																		<label class="col-form-label col-md-3">Fecha de Pago Hasta:</label>
																		<div class="col-sm-9">
																			<input class="form-control col-6" type="date" v-model="finalDatePayment">
																		</div>
																	</div>
																</div>
																<div v-if="selectedBase.value === 3">
																	<div id="general" role="tabpanel" class="tab-pane active">
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Tipo de Boleta:</label>
																			<div class="col-sm-5">
																				<v-select v-model="selectedInvoiceKind" :options="invoiceKindOptions"></v-select>
																			</div>
																		</div>
																	</div>
																	<div class="form-group row m-b-15">
																		<label class="col-form-label col-md-3">Filtrar Monto Desde:</label>
																		<div class="col-sm-9">
																			<input class="form-control col-6" type="Number" v-model="from_amount"></input>
																		</div>
																		<label class="col-form-label col-md-3">Filtrar Monto Hasta:</label>
																		<div class="col-sm-9">
																			<input class="form-control col-6" type="Number" v-model="to_amount"></input>
																		</div>
																	</div>
																	<div id="general" role="tabpanel" class="tab-pane active">
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Pagado:</label>
																			<div class="col-sm-5">
																				<v-select v-model="selectedPagado" :options="pagadoOptions"></v-select>
																			</div>
																		</div>
																	</div>
																	<div id="general" role="tabpanel" class="tab-pane active">
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Operador Boleta:</label>
																			<div class="col-sm-5">
																				<v-select v-model="selectedOpInvoice" :options="opInvoiceOptions"></v-select>
																			</div>
																		</div>
																	</div>
																	<div id="general" role="tabpanel" class="tab-pane active">
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Operador Cliente:</label>
																			<div class="col-sm-5">
																				<v-select v-model="selectedOpCliente" :options="opClienteOptions"></v-select>
																			</div>
																		</div>
																	</div>
																	<div id="general" role="tabpanel" class="tab-pane active">
																		<div class="form-group row m-b-15">
																			<label class="col-form-label col-md-3">Servicio Asignado:</label>
																			<div class="col-sm-5">
																				<v-select v-model="selectedServicioAsignado" :options="servicioAsignadoOptions"></v-select>
																			</div>
																		</div>
																	</div>
																</div>
															</form>
														</div>
														<!-- end col-8 -->
													</div>
													<!-- end row -->
												</fieldset>
												<!-- end fieldset -->
											</div>
											<div id="step-4">
												<!-- begin fieldset -->
												<fieldset>
													<!-- begin row -->
													<div class="row">
														<!-- begin col-8 -->
														<div class="col-xl-8 offset-xl-1">
															<div class="row mb-6">
																<div  class="col-sm-12 col-md-12">
																	<label class="custom-control custom-switch">
																		<input type="checkbox" class="custom-control-input"  id="codigo"  v-on:click="startCodeMirror()">
																		<label class="custom-control-label" for="codigo"> Activar Editor</label>
																	</label>
																	<textarea class="hide" v-model="message" id="codeeditor"></textarea>
																</div>
															</div><br>
															
															<button class="btn" style="background-color: #117864; color:white" v-on:click="checkColumns(), refreshData(0)">Preview</button>
															<button class="btn" style="background-color: #148F77; color:white" v-on:click="checkColumns(), refreshData(1)">Exportar</button>
															<button class="btn" style="background-color: #17a589; color:white" v-on:click="checkColumns(), showNameModal()">Guardar</button>
														</div>
														<!-- end col-8 -->
													</div>
													<!-- end row -->
												</fieldset>
												<!-- end fieldset -->
											</div>
										</div>
									</div>
								  
								<!-- Modal -->
								<div class="modal fade" id="tableModal" tabindex="-1" role="dialog" aria-labelledby="tableModalLabel" aria-hidden="true">
									<div class="modal-dialog modal-lg" role="document">
										<div class="modal-content">
										<div class="modal-header">
											<h5 class="modal-title" id="tableModalLabel">Tabla de prueba</h5>
											<button type="button" class="close" data-dismiss="modal" aria-label="Close">
											<span aria-hidden="true">&times;</span>
											</button>
										</div>
										<div class="modal-body">
											<div>
												<table class="table" style="overflow-x:auto;display: inline-block;">
													{% verbatim %}
													<tr>
														<td v-for="x in columns_names">{{x}}</td>
													</tr>
													<tr v-for="data in data_table">
														<td v-for="value in data">{{value}}</td>
													</tr>
													{% endverbatim %}
												</table>
											</div>
											{% verbatim %}
											<div v-if="columns_names.length != 0">
												<div>Hay {{this.tam}} registros</div>
											</div>
											{% endverbatim %}
										</div>
										<div class="modal-footer">
											<button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
										</div>
										</div>
									</div>
									</div>

								<div class="modal fade" id="exportModal" tabindex="-1" role="dialog" aria-labelledby="exportModalLabel" aria-hidden="true">
									<div class="modal-dialog" role="document">
										<div class="modal-content">
										<div class="modal-header">
											<h5 class="modal-title" id="exportModalLabel">Exportando Datos</h5>
											<button type="button" class="close" data-dismiss="modal" aria-label="Close">
											<span aria-hidden="true">&times;</span>
											</button>
										</div>
										<div class="modal-body">
											{% verbatim %}
											Exportando {{this.tam}} {{this.selectedBase.label}}, (puede tardar unos minutos).
											{% endverbatim %}
										</div>
										<div class="modal-footer">
											<button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
										</div>
										</div>
									</div>
									</div>

								<div class="modal fade" id="errorModal" tabindex="-1" role="dialog" aria-labelledby="errorModalLabel" aria-hidden="true">
									<div class="modal-dialog" role="document">
										<div class="modal-content">
										<div class="modal-header">
											<h5 class="modal-title" id="errorModalLabel">Revisar</h5>
											<button type="button" class="close" data-dismiss="modal" aria-label="Close">
											<span aria-hidden="true">&times;</span>
											</button>
										</div>
										<div class="modal-body">
											{% verbatim %}
											No se pueden exportar {{this.tam}} registros, máximo {{this.exportLimit}}.
											{% endverbatim %}
										</div>
										<div class="modal-footer">
											<button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
										</div>
										</div>
									</div>
								</div>

								<div class="modal fade" id="noColumnsModal" tabindex="-1" role="dialog" aria-labelledby="noColumnsModalLabel" aria-hidden="true">
									<div class="modal-dialog" role="document">
										<div class="modal-content">
										<div class="modal-header">
											<h5 class="modal-title" id="noColumnsModalLabel">Revisar</h5>
											<button type="button" class="close" data-dismiss="modal" aria-label="Close">
											<span aria-hidden="true">&times;</span>
											</button>
										</div>
										<div class="modal-body">
											No se ha seleccionado ninguna columna
										</div>
										<div class="modal-footer">
											<button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
										</div>
										</div>
									</div>
								</div>
								
								<div class="modal fade" id="nameModal" tabindex="-1" role="dialog" aria-labelledby="nameModalLabel" aria-hidden="true">
									<div class="modal-dialog" role="document">
										<div class="modal-content">
										<div class="modal-header">
											<h5 class="modal-title" id="nameModalLabel">Guardar Reporte</h5>
											<button type="button" class="close" data-dismiss="modal" aria-label="Close">
											<span aria-hidden="true">&times;</span>
											</button>
										</div>
										<div class="modal-body">
											<form id="formIndicator">
												<fieldset>
												  <div class="form-group">
													<label for="last">Nombre: </label>
													<input class = "form-control col-6" type="search" v-model="report_name">	
												  </div>
												</fieldset>
											</form>
										</div>
										<div class="modal-footer">
											<button class="btn btn-secondary" v-on:click="refreshData(2)">Guardar</button>
											<button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
										</div>
										</div>
									</div>
								</div>

								<div class="modal fade" id="saveModal" tabindex="-1" role="dialog" aria-labelledby="saveModalLabel" aria-hidden="true">
									<div class="modal-dialog" role="document">
										<div class="modal-content">
										<div class="modal-header">
											<h5 class="modal-title" id="saveModalLabel">Revisar</h5>
											<button type="button" class="close" data-dismiss="modal" aria-label="Close">
											<span aria-hidden="true">&times;</span>
											</button>
										</div>
										<div class="modal-body">
											Se ha guardado el reporte con exito
										</div>
										<div class="modal-footer">
											<button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
										</div>
										</div>
									</div>
								</div>
								
							</div>
						</div>
						<!-- end panel-body -->
						</div>
						<!-- end panel -->
						</div>
						</div>
						<!-- end row -->
						<!--
						<body>
							<textarea class="hide" v-model="message" id="codeeditor"></textarea>
						</body>-->
						<!-- begin scroll to top btn -->
						<a href="javascript:;" class="btn btn-icon btn-circle btn-success btn-scroll-to-top fade" data-click="scroll-top"><i class="fa fa-angle-up"></i></a>
						<!-- end scroll to top btn -->
						
						{% endblock %}

{% block pageleveljs %}
<script type="text/javascript">
    //active menu
    document.getElementById("reports_menu").classList.add("active");
    //active submenu item
    document.getElementById("general_report").classList.add("active");
</script>
<script type="text/javascript" src="{% static 'theme/plugins/codemirror/codemirror.js' %}"></script>
<script type="text/javascript" src="{% static 'theme/plugins/codemirror/python.js' %}"></script>
<script src="{% static 'js/vue' %}"></script>
<script src="{% static 'js/vue-resource' %}"></script>
<script src="{% static 'js/vue-select' %}"></script>
<script src="{% static 'js/lodash.min.js' %}"></script>
<script src ="{% static 'theme/plugins/smartwizard/dist/js/jquery.smartWizard.js' %} "></script>

<script>
    get = function(obj, key) {
	return key.split(".").reduce(function(o, x) {
	    return (typeof o == "undefined" || o === null) ? o : o[x];
	}, obj);
    }

	// Función para activar Wizard
	var handleBootstrapWizards = function() {
	$('#wizard').smartWizard({ 
		selected: 0, 
		theme: 'default',
		transitionEffect:'',
		transitionSpeed: 0,
		useURLhash: false,
		showStepURLhash: false,
		toolbarSettings: {
			toolbarPosition: 'bottom',
		},
		anchorSettings: {
          anchorClickable: true, // Enable/Disable anchor navigation
          enableAllAnchors: true, // Activates all anchors clickable all times
          markDoneStep: false, // add done css
          enableAnchorOnDoneStep: true // Enable/Disable the done steps navigation
      	},
		});
	};
	var FormWizard = function () {
		return {
			//main function
			init: function () {
				handleBootstrapWizards();
			}
		};
	}();
	$(document).ready(function() {
		FormWizard.init();
	});
	

	// Función para exportar reportes
	function export_info(url,send_data)
	{
		var mapForm = document.createElement("form");
		mapForm.target = "Map";
		mapForm.method = "POST";
		mapForm.action = "/export_caller/";

		for (var i in send_data) {
			if (send_data.hasOwnProperty(i)) {
				var input = document.createElement('input');
				input.type = 'hidden';
				input.name = i;
				input.value = send_data[i];
				mapForm.appendChild(input);
			}
  		} 
 	 	document.body.appendChild(mapForm);
		mapForm.submit();		
	}

	// Función para recibir la información de tabla de prueba
	function send_info(url,send_data)
	{	
		var result = $.ajax({
            type: 'POST',
            url: url,
            data: send_data,
			datatype: "json",
			async: false,
        });
		return result.responseText;
	}

	// Función para obtener las columnas seleccionadas
	function get_selected_columns(){
			var lista = [];
			count = 0;
			while(document.getElementById("cx" + count.toString()))
			{
				var box =  document.getElementById("cx" + count.toString());
				if (box.checked == true)
				{
					lista.push(box.value);
				}
				count += 1;
			}
			 return lista;
		 }

  Vue.component('v-select', VueSelect.VueSelect);

  // Register a global custom directive called v-focus
  Vue.directive('focus', {
  // When the bound element is inserted into the DOM...
  inserted: function (el) {
  // Focus the element
  el.focus()
    
  }
  })
  var csrftoken = $("[name=csrfmiddlewaretoken]").val();
    $.ajaxSetup({
    beforeSend: function(xhr, settings) {
        xhr.setRequestHeader("X-CSRFToken", csrftoken);
    }});
  

  var service_status_app = new Vue({
      el: '#service-status-app',
      data: {
      message: "",
	  initiald: "{{ first_of_month }}",
	  finald: "{{ last_of_month }}",
	  export: "0",
	  initDateStatus: "{{filter_status_initDate}}",
	  finalDateStatus: "{{filter_status_finalDate}}",
	  initDateCreated: "{{filter_created_initDate}}",
	  finalDateCreated: "{{filter_created_finalDate}}",
	  initDateActivated: "{{filter_activated_initDate}}",
	  finalDateActivated: "{{filter_activated_finalDate}}",
	  initDateInstalled: "{{filter_installed_initDate}}",
	  finalDateInstalled: "{{filter_installed_finalDate}}",
	  initDateUninstalled: "{{filter_uninstalled_initDate}}",
	  finalDateUninstalled: "{{filter_uninstalled_finalDate}}",
	  initDateExpired: "{{filter_expired_initDate}}",
	  finalDateExpired: "{{filter_expires_finalDate}}",
	  initDatePayment: "{{filter_payment_initDate}}",
	  finalDatePayment: "{{filter_payment_finalDate}}",
	  columns_names: [],
	  data_table: [[]],
	  tam: "",
	  activeCode: "",
	  filter_address: "{{filter_address}}",
	  filter_name: "{{filter_name}}",
	  filter_from_balance: "{{filter_from_balance}}",
	  filter_to_balance: "{{filter_to_balance}}",
	  to_amount: "{{filter_to_amount}}",
	  from_amount: "{{filter_from_amount}}",
	  baseOptions: [{% for base in bases %}{value: {{ base.0 }}, label: "{{ base.1 }}"},{% endfor %}],
	  selectedBase: {value: 0, label: "Clientes"},
	  initialBase: "{{base_model}}",
	  statusOptions: [{value: null, label: "Todos"},{% for status in statuses %}{value: {{ status.code }}, label: "{{ status.name }}"},{% endfor %}],
	  selectedStatus: {value: null, label: "Todos"},
	  initialStatus: "{{filter_status}}",
	  networkOptions: [{value: null, label: "Cualquiera"},{% for net in network_status %}{value: {{ net.0 }}, label: "{{ net.1 }}"},{% endfor %}],
	  selectedNetwork: {value: null, label: "Cualquiera"},
	  initialNetwork: "{{filter_network}}",
	  planOptions: [{value: null, label: "Todos"},{% for plan in plans %}{value: {{ plan.code }}, label: "{{ plan.name }}"},{% endfor %}],
	  selectedPlan: {value: null, label: "Todos"},
	  initialPlan: "{{filter_plan}}",
	  customerKindOptions: [{value: null, label: "Todos"},{% for kind in customer_kind %}{value: {{ kind.0 }}, label: "{{ kind.1 }}"},{% endfor %}],
	  selectedCustomerKind: {value: null, label: "Todos"},
	  initialCustomerKind: "{{filter_customer_kind}}",
	  technologyOptions: [{value: null, label: "Todas"},{% for tech in technology %}{value: {{ tech.0 }}, label: "{{ tech.1 }}"},{% endfor %}],
	  selectedTechnology: {value: null, label: "Todas"},
	  initialTechnology: "{{filter_technology}}",
	  paymentKindOptions: [{value: null, label: "Todos"},{% for kind in payment_kind %}{value: {{ kind.code }}, label: "{{ kind.name }}"},{% endfor %}],
	  selectedPaymentKind: {value: null, label: "Todos"},
	  initialPaymentKind: "{{filter_payment_method}}",
	  manualOptions: [{value: null, label: "Todos"},{% for m in manual %}{value: {{ m.0 }}, label: "{{ m.1 }}"},{% endfor %}],
	  selectedManual: {value: null, label: "Todos"},
	  initialManual: "{{filter_payment_manual}}",
	  opClienteOptions: [{value: null, label: "Todos"},{% for op in operator %}{value: {{ op.0 }}, label: "{{ op.1 }}"},{% endfor %}],
	  selectedOpCliente: {value: null, label: "Todos"},
	  initialOpCliente: "{{filter_payment_cliente_operator}}",
	  agentOptions: [{value: null, label: "Todos"},{% for agent in agents %}{value: {{ agent.0 }}, label: "{{ agent.1}}"},{% endfor %}],
	  selectedAgent: {value: null, label: "Todos"},
	  initialAgent: "{{filter_payment_agent}}",
	  opPaymentOptions: [{value: null, label: "Todos"},{% for op in operator %}{value: {{ op.0 }}, label: "{{ op.1 }}"},{% endfor %}],
	  selectedOpPayment: {value: null, label: "Todos"},
	  initialOpPayment: "{{filter_payment_operator}}",
	  conciliadoOptions: [{value: null, label: "Todos"},{% for con in conciliado %}{value: {{ con.0 }}, label: "{{ con.1 }}"},{% endfor %}],
	  selectedConciliado: {value: null, label: "Todos"},
	  initialConciliado: "{{filter_payment_conciliado}}",
	  servicioAsignadoOptions: [{value: null, label: "Todos"},{% for sa in servicio_asignado %}{value: {{ sa.0 }}, label: "{{ sa.1 }}"},{% endfor %}],
	  selectedServicioAsignado: {value: null, label: "Todos"},
	  initialServicioAsignado: "{{filter_payment_servicio_asignado}}",
	  invoiceKindOptions: [{value: null, label: "Todos"},{% for kind in invoice_kind %}{value: {{ kind.0 }}, label: "{{ kind.1 }}"},{% endfor %}],
	  selectedInvoiceKind: {value: null, label: "Todos"},
	  initialInvoiceKind: "{{filter_invoice_kind}}",
	  pagadoOptions: [{value: null, label: "Todos"},{% for sa in servicio_asignado %}{value: {{ sa.0 }}, label: "{{ sa.1 }}"},{% endfor %}],
	  selectedPagado: {value: null, label: "Todos"},
	  initialPagado: "{{filter_invoice_pagado}}",
	  opInvoiceOptions: [{value: null, label: "Todos"},{% for op in operator %}{value: {{ op.0 }}, label: "{{ op.1 }}"},{% endfor %}],
	  selectedOpInvoice: {value: null, label: "Todos"},
	  initialOpInvoice: "{{filter_invoice_operator}}", 
	  pruebaCode: "",
	  exportLimit: "{{exportLimit}}",
	  report_name: "",
	  selected_columns: [{{selected_columns|safe}}],
	  python_code: [{{python_code|safe}}],
	  python_code_initial: 0,
	  values_initial: 0,
      },
	  
      watch: {
	   selectedBase: function(newBase) {
			if (newBase)
			{
				this.message = 'Refrescando datos...'
			}
			this.changeCodeMirror();
	   },
      },
	  
      mounted: function () {
	  this.startBase();
	  this.refreshData(0);
      },
      methods: {

	  // Modales para indicar tamaño del reporte exportado, o si supera el limite de exportación
	  showModal()
	  {
		if (this.tam < parseInt(this.exportLimit))
		{
			$("#exportModal").modal('show');
		}
		else
		{
			$("#errorModal").modal('show');
		}
	  },

	  // Modal para solicitar el nombre del reporte a guardar
	  showNameModal()
	  {
		$("#nameModal").modal('show');
	  },

	  // Funciones para activar y refrescar el editor de código
	  changeCodeMirror()
	  {
		document.getElementById("codigo").checked = false;
		this.startCodeMirror();
	  },

	  startCodeMirror() 
	  {
		var codigo = document.getElementById("codigo").checked;
		if (codigo)
		{	
				if (this.pruebaCode == '')
				{
					this.pruebaCode = CodeMirror.fromTextArea(document.getElementById("codeeditor"), {
					lineNumbers: true,
					indentUnit: 4,
					indentWithTabs: true,
					mode: 'python',
					})
				}
				if (this.selectedBase.value == '0')
				{
					this.pruebaCode.setValue("# Agregar Filtros\n# Por ejemplo customers = customers.filter(kind == '2')\n\nfor customer in customers:\n\tids.append(customer.id)\n\n# Agregar Campos\nnuevas_columnas = []\ncolumns_names += nuevas_columnas\nfor customer in customers:\n\taux_data = []\n\t#Agregar valores en orden\n\textra_data.append(aux_data)\n");
				}
				else if (this.selectedBase.value == '1')
				{
					this.pruebaCode.setValue("# Agregar Filtros\n# Por ejemplo services = services.filter(kind == '2')\n\nfor service in services:\n\tids.append(service.id)\n\n# Agregar Campos\nnuevas_columnas = []\ncolumns_names += nuevas_columnas\nfor service in services:\n\taux_data = []\n\t#Agregar valores en orden\n\textra_data.append(aux_data)\n");
				}
				else if (this.selectedBase.value == '2')
				{
					this.pruebaCode.setValue("# Agregar Filtros\n# Por ejemplo payments = payments.filter(kind == '2')\n\nfor payment in payments:\n\tids.append(payment.id)\n\n# Agregar Campos\nnuevas_columnas = []\ncolumns_names += nuevas_columnas\nfor payment in payments:\n\taux_data = []\n\t#Agregar valores en orden\n\textra_data.append(aux_data)\n");
				}
				else if (this.selectedBase.value == '3')
				{
					this.pruebaCode.setValue("# Agregar Filtros\n# Por ejemplo invoices = invoices.filter(kind == '2')\n\nfor invoice in invoices:\n\tids.append(invoice.id)\n\n# Agregar Campos\nnuevas_columnas = []\ncolumns_names += nuevas_columnas\nfor invoice in invoices:\n\taux_data = []\n\t#Agregar valores en orden\n\textra_data.append(aux_data)\n");
				}
				$(this.pruebaCode.getWrapperElement()).show();
				this.pruebaCode.refresh();
		}
		else
		{
			if (this.pruebaCode)
			{
				$(this.pruebaCode.getWrapperElement()).hide();
				this.pruebaCode.refresh();
			}
		}
		
	  },

	  // Función para chequear si hay columnas seleccionadas
	  checkColumns()
	  {
		 var columns = get_selected_columns();
		 if (columns.length <= 0 && document.getElementById("codigo").checked == false)
		 {
			 $('#noColumnsModal').modal('show');
		 }  
	  },

	  // Función para inicializar el valor de la Base
	  startBase()
	  {
		if (this.initialBase){ this.selectedBase = {value: parseInt(this.initialBase), label: this.baseOptions[this.initialBase].label};}
	  },

	  // Función para incializar las columnas seleccionadas, filtros y el codigo del editor.
	  initialValues()
	  {
		if ( this.selected_columns[0])
		{
			for (i = 0; i < this.selected_columns[0].length; ++i )
			{
				document.getElementById("cx" + this.selected_columns[0][i]).checked = true;
			}
		}

		if ( this.python_code[0] )
		{
			document.getElementById("codigo").checked = true;
			this.pruebaCode = CodeMirror.fromTextArea(document.getElementById("codeeditor"), {
				lineNumbers: true,
				indentUnit: 4,
				indentWithTabs: true,
				mode: 'python',
			});
			this.pruebaCode.setValue(this.python_code[0]);
			this.python_code_initial = 1;
		}

		if (this.initialCustomerKind){ this.selectedCustomerKind = {value: parseInt(this.initialCustomerKind), label: this.customerKindOptions[this.initialCustomerKind].label};}
		if (this.initialNetwork){ this.selectedNetwork = {value: parseInt(this.initialNetwork), label: this.networkOptions[this.initialNetwork].label};}
		if (this.initialPlan){ this.selectedPlan = {value: parseInt(this.initialPlan), label: this.planOptions[this.initialPlan].label};}
		if (this.initialTechnology){ this.selectedTechnology = {value: parseInt(this.initialTechnology), label: this.technologyOptions[this.initialTechnology].label};}
		if (this.initialStatus){ this.selectedStatus = {value: parseInt(this.initialStatus), label: this.statusOptions[this.initialStatus].label};}
		if (this.initialPaymentKind){ this.selectedPaymentKind = {value: parseInt(this.initialPaymentKind), label: this.paymentKindOptions[this.initialPaymentKind].label};}
		if (this.initialManual){ this.selectedManual = {value: parseInt(this.initialManual), label: this.manualOptions[this.initialManual].label};}
		if (this.initialOpCliente){ this.selectedOpCliente = {value: parseInt(this.initialOpCliente), label: this.opClienteOptions[this.initialOpCliente].label};}
		if (this.initialAgent){ this.selectedAgent = {value: parseInt(this.initialAgent), label: this.agentOptions[this.initialAgent].label};}
		if (this.initialOpPayment){ this.selectedOpPayment = {value: parseInt(this.initialOpPayment), label: this.opPaymentOptions[this.initialOpPayment].label};}
		if (this.initialConciliado){ this.selectedConciliado = {value: parseInt(this.initialConciliado), label: this.conciliadoOptions[this.initialConciliado].label};}
		if (this.initialServicioAsignado){ this.selectedServicioAsignado = {value: parseInt(this.initialServicioAsignado), label: this.servicioAsignadoOptions[this.initialServicioAsignado].label};}
		if (this.initialInvoiceKind){ this.selectedInvoiceKind = {value: parseInt(this.initialInvoiceKind), label: this.invoiceKindOptions[this.initialInvoiceKind].label};}
		if (this.initialPagado){ this.selectedPagado = {value: parseInt(this.initialPagado), label: this.pagadoOptions[this.initialPagado].label};}
		if (this.initialOpInvoice){ this.selectedOpInvoice = {value: parseInt(this.initialOpInvoice), label: this.opInvoiceOptions[this.initialOpInvoice].label};}
	 },

	  refreshData: _.debounce(
         function get_customer_data(exportData){
            var url = '{% url "general-table-ajax" %}';
            send_data = {'number_column': this.number_column};
            send_data['csrfmiddlewaretoken'] =  csrftoken;
			send_data['base_model'] = this.selectedBase.value;
			send_data['elements'] = get_selected_columns();
			send_data['filter_name'] = this.filter_name;
			send_data['filter_address'] = this.filter_address;
			send_data['filter_network'] = this.selectedNetwork.value;
			send_data['filter_status'] = this.selectedStatus.value;
			send_data['filter_from_balance'] = this.filter_from_balance;
			send_data['filter_to_balance'] = this.filter_to_balance;
			send_data['filter_plan'] = this.selectedPlan.value;
			send_data['filter_customer_kind'] = this.selectedCustomerKind.value;
			send_data['filter_created_initDate'] = this.initDateCreated;
			send_data['filter_created_finalDate'] = this.finalDateCreated;
			send_data['filter_activated_initDate'] = this.initDateActivated;
			send_data['filter_activated_finalDate'] = this.finalDateActivated;
			send_data['filter_installed_initDate'] = this.initDateInstalled;
			send_data['filter_installed_finalDate'] = this.finalDateInstalled;
			send_data['filter_uninstalled_initDate'] = this.initDateUninstalled;
			send_data['filter_uninstalled_finalDate'] = this.finalDateUninstalled;
			send_data['filter_expired_initDate'] = this.initDateExpired;
			send_data['filter_expired_finalDate'] = this.finalDateExpired;
			send_data['filter_technology'] = this.selectedTechnology.value;
			send_data['filter_status_initDate'] = this.initDateStatus;
			send_data['filter_status_finalDate'] = this.finalDateStatus;
			send_data['filter_payment_method'] = this.selectedPaymentKind.value;
			send_data['filter_payment_manual'] = this.selectedManual.value;
			send_data['filter_payment_cliente_operator'] = this.selectedOpCliente.value;
			send_data['filter_payment_agent'] = this.selectedAgent.value;
			send_data['filter_payment_operator'] = this.selectedOpPayment.value;
			send_data['filter_payment_conciliado'] = this.selectedConciliado.value;
			send_data['filter_payment_servicio_asignado'] = this.selectedServicioAsignado.value;
			send_data['filter_payment_initDate'] = this.initDatePayment;
			send_data['filter_payment_finalDate'] = this.finalDatePayment;
			send_data['filter_invoice_kind'] = this.selectedInvoiceKind.value;
			send_data['filter_from_amount'] = this.from_amount;
			send_data['filter_to_amount'] = this.to_amount;
			send_data['filter_invoice_pagado'] = this.selectedPagado.value;
			send_data["filter_invoice_operator"] = this.selectedOpInvoice.value;
			if (document.getElementById("codigo").checked)
			{
				send_data["python_code"] = this.pruebaCode.getValue();
			}
			send_data["export_data"] = '0';

			if (exportData == '2')
			{
				send_data["report_name"] = this.report_name;
				var response = send_info('{% url "save-report" %}', send_data);
				response = JSON.parse(response);
				if (response["success"] = "True")
				{
					$("#nameModal").modal('hide');
					$("#saveModal").modal('show');
				}
				return
			}

			var req_info = send_info(url,send_data);
			req_info = JSON.parse(req_info);
			this.columns_names = req_info['columns_names'];
			this.data_table = req_info['data_table'];
			this.tam = req_info['length'];
			this.exportLimit = req_info['export_limit'];
			if (send_data['elements'].length > 0 )
			{ 
				$("#tableModal").modal('show');
			}
			if (send_data['elements'].length > 0 || document.getElementById("codigo").checked)
			{
				if (exportData == '1')
				{
					if (this.tam < parseInt(this.exportLimit))
					{
						send_data["export_data"] = '1';
						export_info(url,send_data);
						$("#exportModal").modal('show');
					}
					else
					{
						$("#errorModal").modal('show');
					}
				}
			}
			if (this.values_initial == 0 )
			{
				this.initialValues();
				this.values_initial= 1;
			}
         },
	  )
      }
  })

    // fugly
    $(function (){
    setInterval(function (){
    $('[data-toggle="popover"]').popover();
    }, 500);
    });

</script>

{% endblock %}